﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace WebTemplate
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.Meter;
                Map1.MapTools.MouseCoordinate.Enabled = true;
                //Map1.MapTools.OverlaySwitcher.Enabled = true;

                GoogleOverlay googleOverlay = new GoogleOverlay("Google Map");
                googleOverlay.GoogleMapType = GoogleMapType.Normal;
                googleOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["GoogleUri"]);
                googleOverlay.IsBaseOverlay = true;
                googleOverlay.IsVisible = false;
                Map1.CustomOverlays.Add(googleOverlay);

                VirtualEarthOverlay veOverlay = new VirtualEarthOverlay("Virtual Earth Map");
                veOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["VEUri"]);
                veOverlay.VirtualEarthMapType = ThinkGeo.MapSuite.WebEdition.VirtualEarthMapType.Road;
                veOverlay.IsBaseOverlay = true;
                veOverlay.IsVisible = false;
                Map1.CustomOverlays.Add(veOverlay);
                
                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay("WMK Map");
                worldMapKitOverlay.Projection = WorldMapKitProjection.SphericalMercator;
                worldMapKitOverlay.IsBaseOverlay = true;
                worldMapKitOverlay.IsVisible = false;
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                Map1.CurrentExtent = new RectangleShape(-10893992, 3941156, -10704160, 3798934);
            }
        }

        protected void BackgroundOptions_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selectedMap = ((DropDownList)sender).SelectedValue;

            Map1.CustomOverlays["Google Map"].IsVisible = false;
            Map1.CustomOverlays["Virtual Earth Map"].IsVisible = false;
            Map1.CustomOverlays["WMK Map"].IsVisible = false;

            if (selectedMap == "GoogleMap")
            {
                ((GoogleOverlay)Map1.CustomOverlays["Google Map"]).GoogleMapType = GoogleMapType.Normal;
                Map1.CustomOverlays["Google Map"].IsVisible = true;
            }
            else if (selectedMap == "GoogleSatHybrid")
            {
                ((GoogleOverlay)Map1.CustomOverlays["Google Map"]).GoogleMapType = GoogleMapType.Hybrid;
                Map1.CustomOverlays["Google Map"].IsVisible = true;
            }
            else if (selectedMap == "GoogleTerrain")
            {
                ((GoogleOverlay)Map1.CustomOverlays["Google Map"]).GoogleMapType = GoogleMapType.Physical;
                Map1.CustomOverlays["Google Map"].IsVisible = true;
            }
            else if (selectedMap == "BingMap")
            {
                ((VirtualEarthOverlay)Map1.CustomOverlays["Virtual Earth Map"]).VirtualEarthMapType = VirtualEarthMapType.Road;
                Map1.CustomOverlays["Virtual Earth Map"].IsVisible = true;
            }
            else if (selectedMap == "BingSat")
            {
                ((VirtualEarthOverlay)Map1.CustomOverlays["Virtual Earth Map"]).VirtualEarthMapType = VirtualEarthMapType.Hybrid;
                Map1.CustomOverlays["Virtual Earth Map"].IsVisible = true;
            }
            else if (selectedMap == "BingTerrain")
            {
                ((VirtualEarthOverlay)Map1.CustomOverlays["Virtual Earth Map"]).VirtualEarthMapType = VirtualEarthMapType.Shaded;
                Map1.CustomOverlays["Virtual Earth Map"].IsVisible = true;
            }
            else if (selectedMap == "WorldMapKit")
            {
                Map1.CustomOverlays["WMK Map"].IsVisible = true;
            }
        }
    }
}
